## ntpsec 1.1.0+dfsg1

=== wscript ===
from __future__ import print_function

import itertools
import os
import shlex
import sys
import time

from waflib import Build
from waflib import Context
from waflib import Scripting
from waflib import Utils
from waflib.Build import (BuildContext, CleanContext, InstallContext,
                          StepContext, ListContext)
from waflib.Context import BOTH
from waflib.Errors import WafError
from waflib.Logs import pprint
from waflib.Tools import waf_unit_test

# Avoid writing .pyc files in wafhelpers/
sys.dont_write_bytecode = True

from wafhelpers.options import options_cmd
from wafhelpers.probes \
    import probe_header_with_prerequisites, probe_function_with_prerequisites
from wafhelpers.test import test_write_log, test_print_log


pprint.__doc__ = None

APPNAME='ntpsec'

out = "build"

config = {
    "out": out,
    "OPT_STORE": {}
}


def help(ctx):
    "Be helpful, give a usage"
    print('''
Usage: waf <command>
    build       Build the project
    check       Run tests
    configure   Configure the project
    dist        Create a release
    install     Install the project
    loccount    Show SLOC count of the source tree

''')


def options(ctx):
    options_cmd(ctx, config)
    ctx.recurse("pylib")


def configure(ctx):
    class oc(Build.BuildContext):
        cmd = 'oc'

        def exec_command(self, cmd, **kw):
            kw['output'] = BOTH
            try:
                err, out = self.cmd_and_log(cmd, **kw)
            except WafError as e:
                self.logger.debug('WafError')
                return e.returncode
            if (len(out) and any(word in out for word
                                 in ['err', 'err:', 'error', 'error:',
                                     'ignored', 'illegal', 'unknown',
                                     'unrecognized', 'warning'])):
                self.logger.debug('noooo %r' % out)
                return 1
            if err:
                self.logger.debug('noooo %r' % err)
                return 1
            return 0

    def msg(str):
        pprint("YELLOW", str)

    def msg_setting(name, val):
        pprint("NORMAL", "  %-30s: " % name, sep="")
        pprint("YELLOW", val)

    srcnode = ctx.srcnode.abspath()
    bldnode = ctx.bldnode.abspath()

    ctx.run_build_cls = 'check'
    ctx.load('waf', tooldir='wafhelpers/')
    ctx.load('waf_unit_test')
    ctx.load('pytest')
    ctx.load('gnu_dirs')

    with open("VERSION", "r") as f:
        ctx.env.NTPSEC_VERSION = f.read().split(" ")[0].strip()

    ctx.env.OPT_STORE = config["OPT_STORE"]

    opt_map = {}
    # Wipe out and override flags with those from the commandline
    for flag in ctx.env.OPT_STORE:
        if flag == "--undefine":
            for sym in ctx.env.OPT_STORE[flag]:
                ctx.undefine(sym)
        elif flag == "--define":
            for symval in ctx.env.OPT_STORE[flag]:
                (sym, val) = symval.split("=")
                try:
                    ctx.define(sym, int(val))
                except ValueError:
                    ctx.define(sym, val)
        else:
            opt = flag.replace("--", "").upper()
            opt_map[opt] = ctx.env.OPT_STORE[flag]

    msg("--- Configuring host ---")
    ctx.setenv('host', ctx.env.derive())

    ctx.load('compiler_c')
    ctx.start_msg('Checking compiler version')
    ctx.end_msg("%s" % ".".join(ctx.env.CC_VERSION))
    # Ensure m4 is present, or bison will fail with SIGPIPE
    ctx.find_program('m4')
    ctx.load('bison')

    for opt in opt_map:
        ctx.env[opt] = opt_map[opt]

    if ctx.options.enable_rtems_trace:
        ctx.find_program("rtems-tld", var="BIN_RTEMS_TLD",
                         path_list=[ctx.options.rtems_trace_path,
                                    '${BINDIR}'])
        ctx.env.RTEMS_TEST_ENABLE = True
        ctx.env.RTEMS_TEST_FLAGS = [
            "-C", "%s/devel/trace/ntpsec-trace.ini" % srcnode,
            "-W", "%s/ntpsec-wrapper" % bldnode,
            "-P", "%s/devel/trace/" % srcnode,
            "-f", "-I%s" % bldnode,
            "-f", "-I%s/include/" % srcnode,
        ]

    # Not needed to build.  Used by utility scripts.
    ctx.find_program("awk", var="BIN_AWK", mandatory=False)
    ctx.find_program("sh", var="BIN_SH", mandatory=False)

    # used to make man and html pages
    ctx.find_program("asciidoc", var="BIN_ASCIIDOC", mandatory=False)
    # make sure asciidoc is new enough.
    # based on check_python_version() from waf
    if ctx.env.BIN_ASCIIDOC:
        # https://lists.ntpsec.org/pipermail/devel/2016-July/001778.html
        asciidocminver = (8, 6, 0)
        # Get asciidoc version string
        cmd = ctx.env.BIN_ASCIIDOC + ['--version']
        # example output: asciidoc 8.6.9
        lines = ctx.cmd_and_log(cmd).split()[1].split(".")
        assert len(lines) == 3, "found %r lines, expected 3: %r" \
            % (len(lines), lines)
        asciidocver_tuple = (int(lines[0]), int(lines[1]), int(lines[2]))

        # Compare asciidoc version with the minimum required
        result = (asciidocver_tuple >= asciidocminver)

        asciidocver_full = '.'.join(map(str, asciidocver_tuple[:3]))
        asciidocminver_str = '.'.join(map(str, asciidocminver))
        ctx.msg('Checking for asciidoc version >= %s' % (asciidocminver_str,),
                asciidocver_full, color=result and 'GREEN' or 'YELLOW')

        if not result:
            del ctx.env.BIN_ASCIIDOC
    ctx.find_program("a2x", var="BIN_A2X", mandatory=False)
    ctx.find_program("xsltproc", var="BIN_XSLTPROC", mandatory=False)

    ctx.env.ENABLE_DOC = False
    if ctx.env.BIN_ASCIIDOC and ctx.env.BIN_XSLTPROC and ctx.env.BIN_A2X:
        ctx.env.ENABLE_DOC = True

    if ctx.options.enable_doc and not ctx.env.ENABLE_DOC:
        ctx.fatal("asciidoc and xsltproc are required in order "
                  "to build documentation")
    elif ctx.options.enable_doc:
        ctx.env.ASCIIDOC_FLAGS = ["-f", "%s/docs/asciidoc.conf"
                                  % ctx.srcnode.abspath()]
        ctx.env.ENABLE_DOC_USER = ctx.options.enable_doc

    # XXX: conditionally build this with --disable-man?
    # Should it build without docs enabled?
    ctx.env.A2X_FLAGS = ["--format", "manpage",
                         "--asciidoc-opts=--conf-file=%s/docs/asciidoc.conf"
                         % ctx.srcnode.abspath()]
    if not ctx.options.enable_a2x_xmllint:
        ctx.env.A2X_FLAGS += ["--no-xmllint"]

    # Disable manpages within build()
    if ctx.options.disable_manpage:
        ctx.env.DISABLE_MANPAGE = True

    if ((os.path.exists(".git") and
            ctx.find_program("git", var="BIN_GIT", mandatory=False))):
        ctx.start_msg("DEVEL: Getting revision")
        cmd = shlex.split("git log -1 --format=%H")
        ctx.env.NTPSEC_REVISION = ctx.cmd_and_log(cmd).strip()
        ctx.end_msg(ctx.env.NTPSEC_REVISION)

    ctx.start_msg("Building version")
    ctx.env.NTPSEC_VERSION_STRING = ctx.env.NTPSEC_VERSION

    if ctx.env.NTPSEC_REVISION:
        ctx.env.NTPSEC_VERSION_STRING += "-%s" % ctx.env.NTPSEC_REVISION[:7]

    if ctx.options.build_version_tag:
        ctx.env.NTPSEC_VERSION_STRING += "-%s" % ctx.options.build_version_tag

    ctx.define("NTPSEC_VERSION_STRING", ctx.env.NTPSEC_VERSION_STRING)
    ctx.end_msg(ctx.env.NTPSEC_VERSION_STRING)

    # We require some things that C99 doesn't enable, like pthreads.
    # These flags get propagated to both the host and main parts of the build.
    #
    # _POSIX_C_SOURCE
    #      If ==1, like _POSIX_SOURCE;
    #      if >=2 add IEEE Std 1003.2;
    #      if >=199309L, add IEEE Std 1003.1b-1993;
    #      if >=199506L, add IEEE Std 1003.1c-1995;
    #      if >=200112L, all of IEEE 1003.1-2004
    #      if >=200809L, all of IEEE 1003.1-2008
    #
    # FIXME: We'd like this to be -D_POSIX_C_SOURCE=200809L -D_XOPEN_SOURCE=600
    # rather than -D_GNU_SOURCE, but that runs into problems in two places:
    # (1) The ISC net handling stuff, where struct in6_addr’ loses a member
    # named s6_addr32 that the macros need, and (2) three BSD functions
    # related to chroot jailing in the sandbox code.
    #
    # Note that _POSIX_C_SOURCE >= 199506L and _GNU_SOURCE both turn on
    # _POSIX_PTHREAD_SEMANTICS and _REENTRANT
    #
    ctx.env.CFLAGS = ["-std=c99", "-D_GNU_SOURCE"] + ctx.env.CFLAGS

    msg("--- Configuring main ---")
    ctx.setenv("main", ctx.env.derive())

    from wafhelpers.check_sizeof import check_sizeof

    for opt in opt_map:
        ctx.env[opt] = opt_map[opt]

    if ctx.options.cross_compiler:
        ctx.env.ENABLE_CROSS = True

        ctx.start_msg("Using Cross compiler CC:")
#           ctx.get_cc_version(ctx.env.CC, gcc=True)
        ctx.end_msg(ctx.options.cross_compiler)

        ctx.env.CC = shlex.split(ctx.options.cross_compiler)
        ctx.env.LINK_CC = shlex.split(ctx.options.cross_compiler)

        if ctx.env["CROSS-CFLAGS"]:
            # Lexically split each part of the CFLAGS, then chain the lists
            iter = [shlex.split(x) for x in opt_map["CROSS-CFLAGS"]]
            ctx.env.CFLAGS = list(itertools.chain.from_iterable(iter))

        if ctx.env["CROSS-LDFLAGS"]:
            # Lexically split each part of the LDFLAGS, then chain the lists
            iter = [shlex.split(x) for x in opt_map["CROSS-LDFLAGS"]]
            ctx.env.LDFLAGS = list(itertools.chain.from_iterable(iter))

    if ctx.options.list:
        from wafhelpers.refclock import refclock_map
        print("ID    Description")
        print("~~    ~~~~~~~~~~~")
        for id in refclock_map:
            print("%-5s %s" % (id, refclock_map[id]["descr"]))

        return

    # These are required by various refclocks
    # needs to be tested before CFLAGS are set
    if ctx.check_endianness() == "big":
        ctx.define("WORDS_BIGENDIAN", 1)

    if ctx.options.enable_leap_testing:
        ctx.define("ENABLE_LEAP_TESTING", 1,
                   comment="Enable leap seconds on other than 1st of month.")

    # check for some libs first.  some options, like stack protector,
    # may depend on some libs, like -lssp
    ctx.check_cc(lib="m", comment="Math library")
    ctx.check_cc(lib="rt", mandatory=False, comment="realtime library")
    ctx.check_cc(lib="execinfo", mandatory=False,
                 comment="BSD backtrace library")
    ret = ctx.check_cc(lib="bsd", mandatory=False,
                       comment="BSD compatibility library")
    if ret:
        ctx.env.LDFLAGS += ["-lbsd"]

    # -lssp and -lssp_nonshared may be needed by older gcc to
    # support "-fstack-protector-all"
    ret = ctx.check_cc(lib="ssp", mandatory=False,
                       comment="libssp")
    if ret:
        ctx.env.LDFLAGS += ["-lssp"]

    ret = ctx.check_cc(lib="ssp_nonshared", mandatory=False,
                       comment="libssp_nonshared")
    if ret:
        ctx.env.LDFLAGS += ["-lssp_nonshared"]

    cc_test_flags = [
        ('f_stack_protector_all', '-fstack-protector-all'),
        ('PIC', '-fPIC'),
        ('PIE', '-pie -fPIE'),
        # this quiets most of macOS warnings on -fpie
        ('unused', '-Qunused-arguments'),
        # This is a useless warning on any architecture with a barrel
        # shifter, which includes Intel and ARM and basically
        # everything nowadays. Even so, we'd enable it out of
        # perfectionism, but the GCC directives that ought to be
        # useful for forcing structure alignment in order to suppress
        # it locally don't seem to be working quite right.
        #('w_cast_align', "-Wcast-align"),
        ('w_cast_qual', "-Wcast-qual"),
        ('w_disabled_optimization', "-Wdisabled-optimization"),
        ('w_float_equal', "-Wfloat-equal"),
        ('w_format', '-Wformat'),
        ('w_format_security', '-Wformat-security'),
        # fails on OpenBSD 6
        ('w_format_signedness', '-Wformat-signedness'),
        ('w_implicit_function_declaration', "-Wimplicit-function-declaration"),

=== attic/wscript ===
def build(ctx):
    bldnode = ctx.bldnode.abspath()

    util = ['sht', 'digest-find', 'digest-timing']

    for name in util:
        ctx(
            target=name,
            features="c cprogram bld_include src_include",
            source=[name + ".c"],
            includes=["%s/%s/" % (bldnode, name)],
            use="ntp M SSL CRYPTO RT THR PTHREAD",
            install_path=None,
        )

=== docs/wscript ===
def build(ctx):

    doc_source = ctx.path.ant_glob("*.txt", excl='*-body.txt')

    ctx(
        source=doc_source,
        target="doc",
    )

    image_source = []
    ctx.path.get_bld().make_node("hints").mkdir()    # create 'hints' directory
    for dir in ["icons", "pic"]:

        files = ctx.path.ant_glob('%s/*' % dir)      # Find images
        ctx.path.get_bld().make_node(dir).mkdir()    # create 'pic' directory
        image_source += files

        # Copy images
        ctx(
            features="subst",
            is_copy=True,
            source=files,
            target=[ctx.path.find_node(dir).get_bld().make_node(x.name)
                    for x in files]
        )

    extra = ["asciidoc.js", "asciidoc.css"]

    # Copy extra files
    ctx(
        features="subst",
        is_copy=True,
        source=extra,
        target=extra
    )

    # Install HTML
    ctx.install_files('${HTMLDIR}', extra +
                      [x.change_ext(".html").name for x in doc_source])
    ctx.install_files('${HTMLDIR}', image_source, relative_trick=True)

=== libntp/wscript ===
def build(ctx):

    libntp_source = [
        "assert.c",
        "authkeys.c",
        "authreadkeys.c",
        "clocktime.c",
        "decodenetnum.c",
        "dolfptoa.c",
        "getopt.c",
        "initnetwork.c",
        "isc_error.c",
        "isc_interfaceiter.c",
        "isc_net.c",
        "macencrypt.c",
        "netof.c",
        "ntp_endian.c",
        "ntp_random.c",
        "ntp_dns.c",
        "numtoa.c",
        "recvbuff.c",
        "refidsmear.c",
        "socket.c",
        "socktoa.c",
        "ssl_init.c",
        "syssignal.c",
    ]

    libntp_source_sharable = [
        "clockwork.c",
        "emalloc.c",
        "hextolfp.c",
        "lib_strbuf.c",
        "msyslog.c",
        "ntp_calendar.c",
        "prettydate.c",
        "statestr.c",
        "systime.c",
        "timespecops.c",
    ]

    if not ctx.env.HAVE_STRLCAT or not ctx.env.HAVE_STRLCPY:
        libntp_source_sharable += ["strl_obsd.c"]

    includes = ctx.env.PLATFORM_INCLUDES

    # C library
    ctx(
        features="c cstlib bld_include src_include",
        includes=includes,
        source=libntp_source + libntp_source_sharable,
        target="ntp",
        use="CRYPTO",
    )

    # Loadable Python extension
    #
    # In theory this should use PYTHONARCHDIR, but that doesn't work on
    # CentOS (at least), for some as-yet-undetermined reason.  On most
    # platforms, PYTHONARCHDIR == PYTHONDIR, anyway.
    ctx(
        features="c cshlib bld_include src_include pyext",
        install_path='${PYTHONDIR}/ntp',
        includes=includes,
        source=["pymodule.c"] + libntp_source_sharable,
        target="../pylib/ntpc",  # Put the output in the pylib directory
        use="M RT CRYPTO",
    )

=== libparse/wscript ===
def build(ctx):
    libparse_source = [
        "binio.c",
        "clk_computime.c",
        "clk_dcf7000.c",
        "clk_hopf6021.c",
        "clk_meinberg.c",
        "clk_rawdcf.c",
        "clk_rcc8000.c",
        "clk_schmid.c",
        "clk_sel240x.c",
        "clk_trimtaip.c",
        "clk_trimtsip.c",
        "clk_varitext.c",
        "clk_wharton.c",
        "data_mbg.c",
        "gpstolfp.c",
        "ieee754io.c",
        "info_trimble.c",
        "parse.c",
        "parse_conf.c",
        "trim_info.c",
    ]

    ctx(
        target="parse",
        features="c cstlib bld_include src_include",
        source=libparse_source,
    )

=== ntpd/wscript ===

def build(ctx):
    srcnode = ctx.srcnode.abspath()
    bldnode = ctx.bldnode.abspath()
    target3 = ctx.srcnode.make_node('ntpd/version.h')
    target4 = ctx.srcnode.make_node('wafhelpers/.autorevision-cache')

    if ctx.variant == "host":
        bison_source = ["ntp_parser.y"]

        ctx(
            features="c src_include bld_include",
            includes=["%s/ntpd/" % srcnode,
                      "%s/" % ctx.bldnode.parent.abspath()
                      ],
            source=bison_source,
            target="bison_obj",
        )

        ctx(
            cwd=srcnode,
            rule='VCS_EXTRA=`cat ${SRC[0]}` wafhelpers/autorevision.sh '
                 '-o ${TGT[1].abspath()} -e VERSION -t h >${TGT[0].abspath()}',
            source=["../VERSION", '../wafhelpers/autorevision.sh'],
            target=[target3, target4],
        )

        # Generate Bison and version.h files first.
        ctx.add_group()

        keyword_gen_source = ["keyword-gen.c", ]

        ctx(
            features="c cprogram bld_include src_include",
            includes=["%s/ntpd/" % bldnode,
                      "%s/" % ctx.bldnode.parent.abspath()
                      ],
            install_path=None,
            source=keyword_gen_source,
            target="keyword-gen",
        )

        # XXX: needs a dependency to rebuild ntp_keyword.h
        #      when keyword-gen is rebuilt

        # Make sure keyword-gen is created next.
        ctx.add_group()

        ctx(
            features="c bld_include src_include",
            rule="%s/ntpd/keyword-gen ${SRC} > ${TGT}" % bldnode,
            source="ntp_parser.tab.h",
            target="ntp_keyword.h"
        )

        # Make sure ntp_keyword.h is created last.
        ctx.add_group()

        return

    libntpd_source = [
        "ntp_control.c",
        "ntp_filegen.c",
        "ntp_leapsec.c",
        "ntp_monitor.c",    # Needed by the restrict code
        "ntp_restrict.c",
        "ntp_util.c",
    ]

    ctx(
        features="c bld_include src_include",
        includes=ctx.env.PLATFORM_INCLUDES,
        source=libntpd_source,
        target="libntpd_obj",
        use="CRYPTO",
    )

    ctx(
        target="ntpd_lib",
        features="c cstlib",
        use="libntpd_obj",
        # use="libntpd_obj bison_obj",
    )

    use_refclock = ""      # XXX: there must be a better way to do this
    if ctx.env.REFCLOCK_ENABLE:

        refclock_source = ["ntp_refclock.c",
                           "refclock_conf.c"
                           ]

        ctx(
            target="refclock",
            features="c bld_include src_include",
            source=refclock_source,
        )
        use_refclock += "refclock"

        for file, define in ctx.env.REFCLOCK_SOURCE:
            ctx(
                defines=["%s=1" % define],
                features="c bld_include src_include",
                # XXX: These need to go into config.h
                #      rather than the command line for the individual drivers
                source="refclock_%s.c" % file,
                target="refclock_%s" % file,
            )
            use_refclock += " refclock_%s" % file

    ntpd_source = [
        "ntp_config.c",
        "ntp_io.c",
        "ntp_loopfilter.c",
        "ntp_packetstamp.c",
        "ntp_peer.c",
        "ntp_proto.c",
        "ntp_sandbox.c",
        "ntp_scanner.c",
        "ntp_signd.c",
        "ntp_timer.c",
        "ntpd.c",
        ctx.bldnode.parent.find_node("host/ntpd/ntp_parser.tab.c")
    ]

    ctx(
        features="c rtems_trace cprogram bld_include src_include",
        includes=["%s/host/ntpd/" % ctx.bldnode.parent.abspath(),
                  "%s/ntpd/" % srcnode,
                  ] + ctx.env.PLATFORM_INCLUDES,
        install_path='${SBINDIR}',
        source=ntpd_source,
        target="ntpd",
        use="libntpd_obj ntp M parse RT CAP SECCOMP PTHREAD NTPD "
            "CRYPTO DNS_SD DNS_SD_INCLUDES %s SOCKET NSL SCF" % use_refclock,
    )

    ctx.manpage(8, "ntpd-man.txt")
    ctx.manpage(5, "ntp.conf-man.txt")
    ctx.manpage(5, "ntp.keys-man.txt")

=== ntpfrob/wscript ===
def build(ctx):
    bldnode = ctx.bldnode.abspath()

    frob_sources = ['main.c', 'bumpclock.c', 'jitter.c', 'precision.c',
                    'pps-api.c', 'tickadj.c']

    ctx(
        features="c cprogram bld_include src_include",
        includes=["%s/ntpfrob/" % bldnode],
        install_path='${BINDIR}',
        source=frob_sources,
        target="ntpfrob",
        use="M RT",
    )

    ctx.manpage(8, "ntpfrob-man.txt")

=== ntptime/wscript ===
def build(ctx):
    if ctx.env.HEADER_SYS_TIMEX_H:
        srcnode = ctx.srcnode.abspath()
        bldnode = ctx.bldnode.abspath()

        ctx(
            target="ntptime",
            features="c cprogram bld_include src_include",
            source=["ntptime.c"],
            includes=["%s/ntptime/" % bldnode,
                      "%s/ntptime/" % srcnode,
                      ],
            use="ntp M RT",
            install_path='${BINDIR}',
        )

    ctx.manpage(8, "ntptime-man.txt")

# end

=== pylib/wscript ===
from waflib import Utils  # pylint: disable=import-error


def options(opt):
    opt.load('python')


def configure(conf):
    conf.load('python')
    conf.check_python_version((2, 6, 0))
    conf.check_python_headers(features='pyext')  # Extension-only, no embedded


def build(ctx):
    srcnode = ctx.srcnode.make_node('pylib')
    bldnode = ctx.bldnode.make_node('pylib')
    target1 = bldnode.make_node('control.py')
    target2 = bldnode.make_node('magic.py')
    target3 = bldnode.make_node('version.py')
    target4 = ctx.srcnode.make_node('wafhelpers/.autorevision-cache')
    sources = srcnode.ant_glob('*.py')
    builds = [x.get_bld() for x in sources]

    # Remove generated files to ensure they are properly updated
    ctx.exec_command("rm -f %s" % target1.abspath())
    ctx.exec_command("rm -f %s" % target2.abspath())
    ctx.exec_command("rm -f %s" % target3.abspath())

    # Make sure Python sees .py as well as .pyc/.pyo
    ctx(
        features="subst",
        source=sources,
        target=builds,
    )

    ctx(
        before=['pyc', 'pyo'],
        cwd=srcnode,
        rule='${SRC} >${TGT}',
        source=["../wafhelpers/pythonize-header", "../include/ntp_control.h"],
        target=target1,
    )

    ctx(
        before=['pyc', 'pyo'],
        cwd=srcnode,
        rule='${SRC} >${TGT}',
        source=["../wafhelpers/pythonize-header", "../include/ntp.h"],
        target=target2,
    )

    ctx(
        before=['pyc', 'pyo'],
        cwd=srcnode,
        rule='VCS_EXTRA=`cat ${SRC[0]}` ../wafhelpers/autorevision.sh '
             '-o ${TGT[1].abspath()} -e VERSION -t python >${TGT[0].abspath()}',
        source=["../VERSION", '../wafhelpers/autorevision.sh'],
        target=[target3, target4],
    )

    # Force early creation of generated files
    ctx.add_group()

    ctx(
        features='py',
        source=builds+[target1, target2, target3],
        install_from=bldnode,
        install_path='${PYTHONDIR}/ntp'
    )

=== tests/wscript ===
import os
from waflib import Utils  # pylint: disable=import-error


def build(ctx):
    srcnode = ctx.srcnode.abspath()
    testsrc = ctx.srcnode.make_node('tests')
    pylib = ctx.srcnode.make_node('pylib')
    testpylib = testsrc.make_node('pylib')
    testpysrc = testpylib.ant_glob('*.py')

    # Unity source
    unity_source = [
        "unity/unity.c",
        "unity/unity_fixture.c",
    ]

    unity_config = ["UNITY_INCLUDE_DOUBLE", "UNITY_SUPPORT_64"]

    ctx(
        defines=unity_config,
        features="c",
        target="unity",
        source=unity_source
    )

    # Test main.
    common_source = [
        "common/tests_main.c",
        "common/caltime.c",
        "common/sockaddrtest.c",
    ]

    # libntp/
    libntp_source = [
        "libntp/authkeys.c",
        "libntp/calendar.c",
        "libntp/clocktime.c",
        "libntp/decodenetnum.c",
        "libntp/hextolfp.c",
        "libntp/lfpfunc.c",
        "libntp/lfptostr.c",
        "libntp/macencrypt.c",
        "libntp/msyslog.c",
        "libntp/netof.c",
        "libntp/numtoa.c",
        "libntp/prettydate.c",
        "libntp/recvbuff.c",
        "libntp/refidsmear.c",
        "libntp/socktoa.c",
        "libntp/statestr.c",
        "libntp/strtolfp.c",
        "libntp/timespecops.c",
        "libntp/vi64ops.c",
        "libntp/ymd2yd.c"
    ] + common_source

    ctx.ntp_test(
        features="c cprogram bld_include src_include test",
        target="test_libntp",
        install_path=None,
        defines=unity_config + ["TEST_LIBNTP=1"],
        includes=["%s/tests/unity/" % srcnode,
                  "%s/tests/libntp/" % srcnode,
                  "%s/tests/ntpdig/" % srcnode,
                  "%s/tests/common/" % srcnode
                  ] + ctx.env.PLATFORM_INCLUDES,
        use="unity ntp parse M PTHREAD CRYPTO RT SOCKET NSL",
        source=libntp_source,
    )

    if ctx.env.REFCLOCK_GENERIC or ctx.env.REFCLOCK_TRIMBLE:
        # libparse available/required wth generic and Trimble refclocks

        # libparse/
        libparse_source = [
            "libparse/binio.c",
            "libparse/gpstolfp.c",
            "libparse/ieee754io.c",
        ] + common_source

        ctx.ntp_test(
            defines=unity_config + ["TEST_LIBPARSE=1"],
            features="c cprogram bld_include src_include test",
            includes=["%s/tests/unity/" % srcnode,
                      "%s/tests/libparse/" % srcnode,
                      "%s/tests/common/" % srcnode
                      ] + ctx.env.PLATFORM_INCLUDES,
            install_path=None,
            lib=["parse"],
            libpath=["libparse"],
            source=libparse_source,
            target="test_libparse",
            use="unity ntp parse M PTHREAD CRYPTO RT SOCKET NSL",
        )

    ntpd_source = [
        # "ntpd/filegen.c",
        "ntpd/leapsec.c",
        "ntpd/restrict.c",
    ] + common_source

    ctx.ntp_test(
        defines=unity_config + ["TEST_NTPD=1"],
        features="c cprogram bld_include src_include test",
        includes=["%s/tests/unity/" % srcnode,
                  "%s/ntpd/" % srcnode,
                  "%s/tests/libntp/" % srcnode,
                  "%s/tests/common/" % srcnode,
                  ],
        install_path=None,
        source=ntpd_source,
        target="test_ntpd",
        use="ntpd_lib libntpd_obj unity ntp "
            "M PTHREAD CRYPTO RT SOCKET NSL",
    )

    testpylib.get_bld().mkdir()

    pypath = pylib.get_bld()
    linkpath = ctx.bldnode.make_node("tests/pylib/ntp")
    if (not linkpath.exists()) or os.readlink(linkpath.abspath()):
        try:
            os.remove(linkpath.abspath())
        except OSError:
            pass
        os.symlink(pypath.abspath(), linkpath.abspath())

    pytests = ["pylib/test_util.py",
               "pylib/test_agentx_packet.py",
               "pylib/test_packet.py",
               "pylib/test_statfiles.py"]

    for path in pytests:
        ctx(
            features="pytest",
            pytest_source=path,
            ut_str="${PYTHON} ${SRC}"
        )

    ctx(
        features="subst",
        source=testpysrc,
        target=[x.get_bld() for x in testpysrc],
        chmod=Utils.O755,
    )

=== debian/changelog ===
ntpsec (1.1.0+dfsg1-1ubuntu0.2) bionic-security; urgency=medium

  * Backport three commits from 1.1.3 to fix (LP: #1812458)
    - CVE-2019-6442: "An authenticated attacker can write one byte out of
      bounds in ntpd via a malformed config request, related to
      config_remotely in ntp_config.c, yyparse in ntp_parser.tab.c, and
      yyerror in ntp_parser.y."
    - CVE-2019-6443: "Because of a bug in ctl_getitem, there is a stack-based
      buffer over-read in read_sysvars in ntp_control.c in ntpd.
    - CVE-2019-6444: "process_control() in ntp_control.c has a stack-based
      buffer over-read because attacker-controlled data is dereferenced by
      ntohl() in ntpd."
    - CVE-2019-6445: "An authenticated attacker can cause a NULL pointer
      dereference and ntpd crash in ntp_control.c, related to ctl_getitem."

 -- Richard Laager <rlaager@wiktel.com>  Fri, 18 Jan 2019 20:07:06 -0600

ntpsec (1.1.0+dfsg1-1ubuntu0.1) bionic; urgency=medium

  * Update apparmor for new drift temp file (LP: #1788102)

 -- Richard Laager <rlaager@wiktel.com>  Tue, 21 Aug 2018 00:27:21 -0500

ntpsec (1.1.0+dfsg1-1) unstable; urgency=medium

  * Make ntpsec Conflict with ntpdate
    - Use ntpsec-ntpdate instead of ntpdate.
  * Stop deleting /var/lib/ntpdate/ (Closes: 892966)
    Thanks to Bernhard Schmidt <berni@debian.org> for the suggestion.
  * New upstream version
    - Digests longer then 20 bytes will be truncated.
    - We have dropped support for Broadcast servers.
    - A bug that caused the rejection of 33% of packets from Amazon time
      service has been fixed.
  * Drop patches merged upstream
    - fix-ntpdig.patch
    - systemd-remove-extra-dependencies.patch
    - fix-name-of-psutil.patch
    - fix-spectracom-log-prefixes.patch
    - fix-ntpviz-file-encodings.patch
    - systemd-remove-remainafterexit.patch
    - systemd-use-high-priority.patch
    - systemd-ionice-ntpviz.patch
    - systemd-cleanup-ntp-wait-service.patch
    - fix-ntploggps.patch
    - systemd-use-usr-sbin.patch
    - systemd-do-not-restart.patch
    - systemd-allow-running-in-containers.patch
    - Merge-Classic-fix-for-CVE-2018-7182.patch
  * Update copyright

 -- Richard Laager <rlaager@wiktel.com>  Fri, 16 Mar 2018 00:42:24 -0500

ntpsec (1.0.0+dfsg1-5) unstable; urgency=high

  * Fix CVE-2018-7182

 -- Richard Laager <rlaager@wiktel.com>  Wed, 07 Mar 2018 19:47:34 -0600

ntpsec (1.0.0+dfsg1-4) unstable; urgency=medium

  * Remove empty /var/log/ntpstats on ntpviz removal
  * Fix installing ntpsec-ntpviz without ntpsec (Closes: 891278)
  * systemd: Allow running in containers (Closes: 890771)

 -- Richard Laager <rlaager@wiktel.com>  Sun, 04 Mar 2018 15:06:58 -0600

ntpsec (1.0.0+dfsg1-3) unstable; urgency=medium

  * Add Vcs-* headers
  * Update Standards-Version to 4.1.3
  * Improve debian/copyright (Closes: 890758)
  * Bump the autorevision version requirement (Closes: 890761)
  * Fix FTBFS when building arch-indep only.
    Thanks to Daniel Baumann <daniel.baumann@progress-linux.org>
    (Closes: 890762)
  * Make ntpsec-ntpdate depend on python3-ntp (Closes: 890770)
  * Inline the SHM message in README.Debian
  * Add note about AppArmor tunable in README.Debian.
    Thanks to Bernhard Schmidt <berni@debian.org>
  * Drop historic Breaks/Pre-Depends.
    Thanks to Bernhard Schmidt <berni@debian.org>
  * ntpsec: Stop creating /var/log/ntpstats
  * ntpsec-ntpviz: Add Suggests: python
  * Create /var/lib/ntp in the postinst
  * Do not recursively chown /var/log/ntpstats
  * Suppress a lintian warning
  * Drop historic apparmor Suggests/Breaks/Replaces
  * Changes as of ntp_4.2.8p10+dfsg-6 have been merged as appropriate.

 -- Richard Laager <rlaager@wiktel.com>  Wed, 21 Feb 2018 00:29:24 -0600

ntpsec (1.0.0+dfsg1-2) unstable; urgency=medium

  * debian/apparmor-profile: add attach_disconnected.
    Thanks to Christian Ehrhardt <christian.ehrhardt@canonical.com>
  * Fix reading the drift file on startup
  * Drop the ntpwait "quick mode" patch

 -- Richard Laager <rlaager@wiktel.com>  Wed, 13 Dec 2017 17:18:10 -0600

ntpsec (1.0.0+dfsg1-1) unstable; urgency=medium

  * Initial release. (Closes: #819806)
    The packaging was originally forked from ntp_4.2.8p8+dfsg.
    Changes as of ntp_4.2.8p10+dfsg-5 have been merged.

 -- Richard Laager <rlaager@wiktel.com>  Thu, 30 Nov 2017 21:29:52 -0600

=== debian/control ===
Source: ntpsec
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Richard Laager <rlaager@wiktel.com>
Uploaders: tony mancill <tmancill@debian.org>
Build-Depends: asciidoc,
               autorevision (>= 1.21),
               bison,
               debhelper (>= 10),
               dh-apache2,
               dh-apparmor,
               dh-python,
               docbook-xsl,
               libcap2-dev [linux-any],
               libssl-dev (>= 1.0.0e-1),
               netbase,
               pps-tools [linux-any],
               python3 (>= 3.3),
               python3-all-dev,
               python3-dev (>= 3.3),
               xsltproc
X-Python3-Version: >= 3.3
Build-Conflicts: libavahi-compat-libdnssd-dev,
                 libwww-dev,
                 libwww-ssl-dev
Standards-Version: 4.1.3
Vcs-Browser: https://github.com/rlaager/ntpsec-pkg
Vcs-Git: https://github.com/rlaager/ntpsec-pkg.git
Homepage: https://www.ntpsec.org

Package: ntpsec
Architecture: any
Depends: adduser,
         lsb-base (>= 3.2-13),
         netbase,
         python3 (>= 3.3),
         python3-ntp,
         tzdata (>= 2015d-1),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: systemd | cron | cron-daemon
Suggests: apparmor,
          ntpsec-doc,
          ntpsec-ntpviz
Breaks: apparmor-profiles-extra (<< 1.8)
Conflicts: ntp,
           ntpdate,
           time-daemon
Provides: time-daemon
Replaces: ntp,
          time-daemon
Description: Network Time Protocol daemon and utility programs
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 This package contains the NTP daemon and utility programs.  An NTP
 daemon needs to be running on each host that is to have its clock
 accuracy controlled by NTP.  The same NTP daemon is also used to
 provide NTP service to other hosts.
 .
 This is the NTPsec version of NTP.  NTPsec is a secure, hardened,
 and improved implementation derived from the original NTP project.
 .
 For more information about the NTP protocol and NTP server
 configuration and operation, install the package "ntpsec-doc".

Package: ntpsec-ntpdate
Architecture: any
Depends: netbase,
         python3 (>= 3.3),
         python3-ntp,
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: ntpdate
Replaces: ntpdate
Description: client for setting system time from NTP servers
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 ntpdate is a simple NTP client that sets a system's clock to match
 the time obtained by communicating with one or more NTP servers.  It
 is not sufficient, however, for maintaining an accurate clock in the
 long run.  ntpdate by itself is useful for occasionally setting the
 time on machines that do not have full-time network access, such as
 laptops.
 .
 This is the NTPsec version of ntpdate.  NTPsec is a secure, hardened,
 and improved implementation derived from the original NTP project.
 .
 If the full NTP daemon from the package "ntpsec" is installed, then
 ntpsec-ntpdate is not necessary.

Package: ntpsec-ntpviz
Architecture: any
Depends: adduser,
         fonts-liberation,
         gnuplot,
         python3 (>= 3.3),
         python3-ntp,
         systemd | cron | cron-daemon,
         ${misc:Depends}
Recommends: ntpsec,
            systemd | python3-psutil,
            ${misc:Recommends}
Suggests: python,
          python-gps
Description: NTP statistics graphing utility
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 ntpviz analyzes NTP log files and generates statistical plots from
 them.  The output is in the form of HTML with images.  If Apache is
 installed, it will be served at: /ntpviz
 .
 This is part of NTPsec.  NTPsec is a secure, hardened, and improved
 implementation derived from the original NTP project.

Package: ntpsec-doc
Architecture: all
Depends: ${misc:Depends}
Section: doc
Multi-Arch: foreign
Description: Network Time Protocol documentation
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 This package contains HTML documentation for the ntpsec packages (ntpsec,
 ntpsec-ntpdate).
 .
 This is part of NTPsec.  NTPsec is a secure, hardened, and improved
 implementation derived from the original NTP project.

Package: python3-ntp
Architecture: any
Depends: python3 (>= 3.3),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Provides: ${python3:Provides}
Section: python
Description: Python 3 NTP Helper Classes
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 This package contains the Python "ntp" module, which contains helper
 classes for NTP utilities written in Python.
 .
 This is part of NTPsec.  NTPsec is a secure, hardened, and improved
 implementation derived from the original NTP project.

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg\d*$//,pgpsigurlmangle=s%$%.asc%,repack" \
  https://ftp.ntpsec.org/pub/releases/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@ \
  debian debian/repack-waf
